#define PAGES_MAX 100
#define gPageMark TEXT("NEXTPAGE")
#define gPageMarkLen 8

#include <windows.h>
#include <stdio.h>
#include "AddUnicode.h"

LPTCH glpText = NULL;
TCHAR* gpszPage[PAGES_MAX];
long glPageCount;
long glTextLen;


long CreatePages(TCHAR* src, TCHAR* dst, long len)
{
	TCHAR pszBuffer[gPageMarkLen+1];
	long count = 0;
	glPageCount = 0;
	gpszPage[glPageCount] = dst;

	while (count < len)
	{
		sscanf(src, TEXT("%8s"), pszBuffer);
		if (lstrcmp(pszBuffer, gPageMark) == 0)
		{
			*dst++ = 0x00;
			glPageCount++;
			gpszPage[glPageCount] = dst;

			while (*src == '\r' || *src == '\n')
//			while (*src == 0x0D || *src == 0x0A)
			{
				src++;
				count++;
			}
			src += gPageMarkLen;
			count += gPageMarkLen;
			while (*src == '\r' || *src == '\n')
//			while (*src == 0x0D || *src == 0x0A)
			{
				src++;
				count++;
			}
		}
		else
		if (*src == '\r')
//		if (*src == 0x0D)
		{
			src++;
			count++;
		}
		else
		if (*src == '\n')
//		if (*src == 0x0A)
		{
			src++;
			count++;
			*dst++ = ' ';
//			*dst++ = 0x20;
		}
		else
		{
			*dst++ = *src++;
			count++;
		}
	}
	// end with 0
	*dst = 0x00;
	// count from 1..n
	glPageCount++;
	return glPageCount;
}

BOOL LoadText(TCHAR* pszFilename, long* plTrials)
{
	HANDLE hFile;
	BOOL bSucceeded;
	DWORD dwBytesRead;
	LPTCH lpTemp = NULL;

	hFile = CreateFile(pszFilename,
		GENERIC_READ,
		(DWORD) 0,
		NULL,
		OPEN_EXISTING, 
		FILE_ATTRIBUTE_NORMAL,
		(HANDLE) 0);
	if (hFile == INVALID_HANDLE_VALUE)
	{
		return FALSE;
	}
	// else
	glTextLen = GetFileSize(hFile, NULL);
	lpTemp = (LPTCH) GlobalAlloc(0, glTextLen);
	bSucceeded =  ReadFile(
	hFile,                // handle of file to read
	lpTemp,             // pointer to buffer that receives data
	glTextLen,  // number of bytes to read
	&dwBytesRead, // pointer to number of bytes read
	NULL   // pointer to structure for data
	);
	CloseHandle(hFile);
	if (!bSucceeded)
	{
		GlobalFree((HGLOBAL) lpTemp);
		return FALSE;
	}
	// else
	glpText = (LPTCH) GlobalAlloc(0, glTextLen);
	*plTrials = CreatePages(lpTemp, glpText, glTextLen);
	GlobalFree((HGLOBAL) lpTemp);
	
	return TRUE;
}

void ReleaseText()
{
	GlobalFree((HGLOBAL) glpText);
}

TCHAR* GetPage(long pageno)
{
	if (pageno <= glPageCount)
	{
		return gpszPage[pageno-1];
	}
	else
	{
		return NULL;
	}
}
